## net.sf.saxon.sort
Class ComparableAtomicValueComparer

    java.lang.Object
      net.sf.saxon.sort.ComparableAtomicValueComparer

All Implemented Interfaces:
  java.io.Serializable, AtomicComparer

Direct Known Subclasses:
  DecimalSortComparer

    public class ComparableAtomicValueComparer

extends java.lang.Object
implements AtomicComparer

A comparer for comparing two "ordinary" atomic values, where the values implement the Comparable interface and the equals() method with the appropriate XPath semantics. This rules out use of collations, conversion of untyped atomic values, and context dependencies such as implicit timezone.

See Also:
  Serialized Form

Constructor Summary
`protected` `ComparableAtomicValueComparer()`

Method Summary
`int` `compareAtomicValues(AtomicValue a, AtomicValue b)` Compare two AtomicValue objects according to the rules for their data type.
`boolean` `comparesEqual(AtomicValue a, AtomicValue b)` Compare two AtomicValue objects for equality according to the rules for their data type.
`ComparisonKey` `getComparisonKey(AtomicValue a)` Get a comparison key for an object.
`static ComparableAtomicValueComparer` `getInstance()` Get the singleton instance of this class
`AtomicComparer` `provideContext(XPathContext context)` Supply the dynamic context in case this is needed for the comparison

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ComparableAtomicValueComparer

    protected ComparableAtomicValueComparer()

Method Detail

### getInstance

    public static ComparableAtomicValueComparer getInstance()

  Get the singleton instance of this class

  Returns:
    the singleton instance of this class

### provideContext

    public AtomicComparer provideContext(XPathContext context)

  Supply the dynamic context in case this is needed for the comparison

  Specified by:
    `provideContext` in interface `AtomicComparer`
  Parameters:
    `context` - the dynamic evaluation context
  Returns:
    either the original AtomicComparer, or a new AtomicComparer in which the context is known. The original AtomicComparer is not modified

### compareAtomicValues

    public int compareAtomicValues(AtomicValue a,
                                   AtomicValue b)

  Compare two AtomicValue objects according to the rules for their data type. UntypedAtomic values are compared as if they were strings; if different semantics are wanted, the conversion must be done by the caller.

  Specified by:
    `compareAtomicValues` in interface `AtomicComparer`
  Parameters:
    `a` - the first object to be compared. This must be an AtomicValue and it must implement Comparable with context-free XPath comparison semantics
    `b` - the second object to be compared. This must be an AtomicValue and it must implement Comparable with context-free XPath comparison semantics
  Returns:
    <0 if a<b, 0 if a=b, >0 if a>b
  Throws:
    `java.lang.ClassCastException` - if the objects are not comparable

### comparesEqual

    public boolean comparesEqual(AtomicValue a,
                                 AtomicValue b)

  Compare two AtomicValue objects for equality according to the rules for their data type. UntypedAtomic values are compared by converting to the type of the other operand.

  Specified by:
    `comparesEqual` in interface `AtomicComparer`
  Parameters:
    `a` - the first object to be compared. This must be an AtomicValue and it must implement equals() with context-free XPath comparison semantics
    `b` - the second object to be compared. This must be an AtomicValue and it must implement equals() with context-free XPath comparison semantics
  Returns:
    true if the values are equal, false if not
  Throws:
    `java.lang.ClassCastException` - if the objects are not comparable

### getComparisonKey

    public ComparisonKey getComparisonKey(AtomicValue a)

  Get a comparison key for an object. This must satisfy the rule that if two objects are equal, then their comparison keys are equal, and vice versa. There is no requirement that the comparison keys should reflect the ordering of the underlying objects.

  Specified by:
    `getComparisonKey` in interface `AtomicComparer`

Copyright (c) Saxonica Limited. All rights reserved.